# Name :          V3DTools 1.0.6
# Author :        Thierry Videlaine
# History:        Initially created to emulate basic dialogs.
#                 
require 'Sketchup.rb'

#----------------------------------------------------------------------------------------------
# M O V E T O
#----------------------------------------------------------------------------------------------
#
class MoveTo

   def MoveTo::move
      if checkselection(true)
        obj = Sketchup.active_model.selection[0]
        box = obj.bounds
        p = Geom::Point3d.new(box.center)
        values = p.x, p.y, p.z
        results = inputbox ["X (Red)","Y (Green)", "Z (Blue)"], values, "Move To"
        return if not results
        x, y, z = results
        x = (x - p.x)
        y = (y - p.y)
        z = (z - p.z)
        l = (box.width / 2).to_m
        w = (box.height / 2).to_m
        h = (box.depth / 2).to_m
        x = (x - l)
        y = (y - w)
        z = (z - h)
        obj.transform!(Geom::Transformation.translation [x, y, z])
      else
        UI.messagebox "Only Groups and Components can be moved!"
      end
      Sketchup.active_model.active_view.invalidate
   end

   def MoveTo::checkselection(lock_check)
      sel_obj = Sketchup.active_model.selection[0]
      if sel_obj
         case sel_obj.typename
            when "Group","ComponentInstance"
               return nil if (Sketchup.active_model.selection[0].locked? & lock_check)
               return true
         end
      end
      return nil
   end

end

#----------------------------------------------------------------------------------------------
# M A I N L I N E
#----------------------------------------------------------------------------------------------
#
if( not file_loaded?("V3DTools.rb") )
   TVI_menu = UI.menu("Plugins").add_submenu("V3DTools") 
   TVI_menu.add_item("Move To"){ MoveTo.move }
end

file_loaded("V3DTools.rb")

